<h1 align="center">"Rigorous KAM results around arbitrary periodic orbits for Hamiltonian Systems."</h1>
<h2 align="center">T.Kapela, C.Simo</h2>

<h2  align="center"> An instruction how to compile and run programs that perform computations for computer assisted proofs of KAM stability 
</h2>


REQUIREMENTS
------------

Programs require CAPD-DynSys 4 library with multiprecision support (MPFR library).
Source code or binary packages along with installation instructions 
can be found on

[CAPD web page](http://capd.ii.uj.edu.pl/)

[CAPD LATEST VERSION](http://sourceforge.net/projects/capd/files/newest/) 

Compiler: The program must be compiled with gcc-4.8 or newer.

COMPILATION
-----------

 1. Unpack archive 
    
    `tar -xf KAMstability.tar.gz`

 2. (optional) If CAPD is installed to the non-standard localization (/usr/local/)
    open file KAMstability/Makefile and edit line with 
    
    `CAPDBINDIR =`
    
    to point to the directory with the CAPD scripts e.g. mpcapd-config.
    Path has to end with / e.g. 
    
    `CAPDBINDIR = /home/user/capd/bin/`
  
   
 3. Change directory to KAMstability and call `make`
     
      `cd KAMstability` <br>
      `make`
     


 4.  After succesfull compilation executable files `H4Proof` and `EightProof`, 
     which perform proofs, are placed in the current directory

PROOFS
------

Main programs, which perform proofs, are 
   
   * **H4Proof** - computations for the quartic potential,
   * **EightProof** - computations for figure Eight solutions of the N-body problem.

They perform the following steps:
  
  1. refining of approximated initial conditions of a periodic orbit
  2. proof of the periodic orbit existence and computation of rigorous enclosure of
     its initial conditions
  3. computations of the Taylor expansion of Poincare map at periodic orbit i.c.
  4. computations of a normal form and verification of non-degeneracy conditions
    
    
Command line arguments:
 
  1. input file : containing approximated initial conditions 
                  and parameters of the computations 
  2. output file (optional) 

Input files for proofs described in article are stored in data directory:
 
  * `quartic_3.txt`, `quartic_16.txt` - period 3 nad 16 orbits of quartic potential
  * `eight.txt` - figure eight solution of the N-body problem
  * `eight_148.txt`, `eight_488.txt`, `eight_794.txt` - rotating eight with angular 
    momentum equal to 0.148, 0.00488, 0.794 respectively.

To perform e.g. proof of KAM stability of period 3 orbit for quartic potential run command 

`./H4Proof data/quartic_3.txt  result.txt`  

The output will be written to the screen and file result.txt will 
contain computed normal form, rigorous estimates of initial conditions 
and parameters used in computations.

In the current directory file output.tex will be created with 
the results in the LaTeX form, similar to the one given in article. 

PRECOMPUTED RESULTS
-------------------

The directory result contains example output files from proofs performed on authors computers.
The actual result can slightly differ depending on operating system, processor
and/or compiler used. 
  

REMARKS
-------

Time of computations for figure eight solution is ca 2 hours.

Under Linux depending on your system settings to run programs you may have to 
set `LD_LIBRARY_PATH` to point to directory with CAPD libraries  e.g. by calling
   
   `export LD_LIBRARY_PATH=/usr/local/lib`
   
or run 
   
   `ldconfig`

Programs were tested on 

  * Linux Mint 16, Ubuntu 13.10, GCC 4.8.1, Intel(R) Core(TM) i7-4600U CPU @ 2.10GHz
  * Debian Lixux 8, GCC 4.9.1,  Intel(R) Xeon(R) CPU E7- 8837  @ 2.67GHz
  * Ubuntu 16.04.2, GCC 5.4.0, Intel(R) Core(TM) i7-4600U CPU @ 2.10GHz
