/**
 *  @file existenceProof.cpp
 *
 *  @author kapela  @date 2011-01-13
 */

#include "typedefs.h"
#include "ioUtils.h"
//#include "ChoreoMap.h"
#include "H4Map.h"
#include "improveIC.h"
#include "MyPoincareMap.h"
#include "existenceProof.h"
#include "Parameters.h"
#include "CnCoeffUtils.h"

#include "Proof.h"
#include "H4Map.h"


using namespace capd::autodiff;
using namespace capd::diffAlgebra;



int main(int argc, char **argv) {
 
//  typedef H4BasicMap<PoincareMap > NonRigorousH4Map;
//  typedef H4Map<IPoincareMap> RigorousMap;
  typedef H4Map< ICnPoincareMap>  RigorousCnMap;
  
  capd::sout << "\n H4 compute Cn coefficients \n";
  
  std::string dataFile = "", resultFile = "";
  ProofStage startStage = ProofStage::CnComputation; 
  
  if(readCommandLineParametersWithStage(argc, argv, dataFile, resultFile, startStage ))
    return 0;

  capd::auxil::ConfigFileReader ini(dataFile);
  ICnCoeff coeff;
  readConfigFile(ini, dataFile, startStage, &coeff);
  
  ParametersSet<IVector> params;
  params.readParameters(ini);
  
  if(startStage != ProofStage::CnComputation)
    return 0;
      
  coeff = computeCn<RigorousCnMap>(params.ode, params.computeCn);
  
  std::cout << "\n Parameters \n"<< params.computeCn 
          << "\n coeff " << coeff.toString(0, coeff.dimension(), 0, 0, coeff.degree(), capd::TypeTraits<Float>::numberOfDigits()+1 )
          << std::endl;
  printDiam(std::cout, coeff);
  saveProofResults(resultFile, params, &coeff);  
  
  return 0;
}
